INCLUDE submodules/shared-utilities/memory_map.ld
ENTRY(Reset_Handler)

__std_heap_size__ = 1024;
__stack_size__ = 2048;

SECTIONS {
    .image_hdr : {
        KEEP(*(.image_hdr))
    } > app

    .note : {
        PROVIDE (g_note_build_id = .);
        *(.note.gnu.build-id)
    } > app

    .text : {
		. = ALIGN(512);
        KEEP(*(.vectors))
        __Vectors_End = .;
        __Vectors_Size = __Vectors_End - __Vectors;

        *(.text*)            /* executable code */
        *(.glue_7 .glue_7t)  /* arm-to-thumb/thumb-to-arm glue code */

        KEEP(*(.init))
        KEEP(*(.fini))

        *(.rodata*)

        KEEP(*(.eh_frame*))

		. = ALIGN(4);
		/* preinit data */
		PROVIDE (__preinit_array_start = .);
		KEEP(*(.preinit_array))
		PROVIDE (__preinit_array_end = .);

		. = ALIGN(4);
		/* init data */
		PROVIDE (__init_array_start = .);
		KEEP(*(SORT(.init_array.*)))
		KEEP(*(.init_array))
		PROVIDE (__init_array_end = .);

		. = ALIGN(4);
		/* finit data */
		PROVIDE (__fini_array_start = .);
		KEEP(*(SORT(.fini_array.*)))
		KEEP(*(.fini_array))
		PROVIDE (__fini_array_end = .);
    } > app

    .uavcan_registers : {
		. = ALIGN(4);
		__uavcan_registers_start__ = .;
		KEEP(*(.uavcan_registers))
		__uavcan_registers_end__ = .;
    } > app

    .data : {
        . = ALIGN(4);
        __data_start__ = .;
        *(.data*)   /* static variables which have an initial value at boot */
        . = ALIGN(4);
        __data_end__ = .;
    } > app_ram AT > app

    __data_load__ = LOADADDR(.data);

    .crc : ALIGN(8) {
        . = ((. + 4 + (8 - 1)) & ~(8 - 1)) - 4;
        __image_crc = .;
        LONG(0x1badc0de)
        __image_end = .;
    } > app =0x5a

    .bss (NOLOAD) : {
        . = ALIGN(4);
        __bss_start__ = .;
        *(.bss*)    /* uninitialized static memory */
        *(COMMON)   /* global uninitialized variables that go beyond file scope */
        . = ALIGN(4);
        __bss_end__ = .;
    } > app_ram

    .std_heap : {
        __HeapBase = .;
        __end__ = .;
        end = __end__;
        . += __std_heap_size__;
        __HeapLimit = .;
    } > app_ram

	__StackTop = ORIGIN(app_ram) + LENGTH(app_ram);
	__StackLimit = __StackTop - __stack_size__;
	PROVIDE(__stack = __StackTop);

	/* Check if data + heap + stack exceeds RAM limit */
	ASSERT(__StackLimit >= __HeapLimit, "region RAM overflowed with stack")

    /* Remove information from the standard libraries */
    /DISCARD/ : {
        libc.a ( * )
        libm.a ( * )
        libgcc.a ( * )
    }

    .ARM.attributes 0 : { *(.ARM.attributes) }
}
